## kissplice 2.1.0

=== CMakeLists.txt ===
# ============================================================================
# Require minimal version of cmake
# ============================================================================
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.4)


# ============================================================================
# Set project name and languages
# ============================================================================
PROJECT(kissplice CXX C)


# ============================================================================
# Set compilation flags
# ============================================================================
IF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE Distribution)
ENDIF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
SET(CMAKE_CXX_FLAGS_DEBUG "-g -Wall")
SET(CMAKE_C_FLAGS_DEBUG "-g -Wall")
SET(CMAKE_CXX_FLAGS_RELEASE "-O3 -Wall")
SET(CMAKE_C_FLAGS_RELEASE "-O3 -Wall")
SET(CMAKE_CXX_FLAGS_DISTRIBUTION "-O3 -w")
SET(CMAKE_C_FLAGS_DISTRIBUTION "-O3 -w")
SET(CMAKE_CXX_FLAGS_PROFILING "-g -pg")
SET(CMAKE_C_FLAGS_PROFILING "-g -pg")


# ============================================================================
# Manage the KMERS_OVER_32 option
# The default value for KMERS_OVER_32 is
#   * ON on 64 bits systems
#   * OFF on 32 bits systems
# If a user tries to set KMERS_OVER_32 to ON on a 32 bits system, it will be
# forced back to OFF in the CACHE and a FATAL_ERROR message will be issued.
# ============================================================================
SET(KMERS_OVER_32_HELP_STRING "Increase the maximum k-mer size on 64-bits systems")

IF (${CMAKE_SIZEOF_VOID_P} LESS 8 )
  set(KMERS_OVER_32 OFF CACHE BOOL KMERS_OVER_32_HELP_STRING)
  IF (KMERS_OVER_32)
    set(KMERS_OVER_32 OFF CACHE BOOL KMERS_OVER_32_HELP_STRING FORCE)
    MESSAGE(FATAL_ERROR
            "The KMERS_OVER_32 option cannot be used on 32 bits systems")
  ENDIF ()
ELSE ()
  set(KMERS_OVER_32 ON CACHE BOOL KMERS_OVER_32_HELP_STRING)
ENDIF ()

# ============================================================================
# Tell cmake which directory to put executables files in
# ============================================================================
SET(MAIN_BIN_DIR ${PROJECT_BINARY_DIR}/bin)           # Main program
SET(SEC_BIN_DIR ${PROJECT_BINARY_DIR}/lib/kissplice)  # Other executables
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SEC_BIN_DIR})


# ============================================================================
# Tell cmake about subdirectories to look into
# ============================================================================
ADD_SUBDIRECTORY(debruijn-v4)
ADD_SUBDIRECTORY(thirdparty)
ADD_SUBDIRECTORY(modules)
ADD_SUBDIRECTORY(man)
ADD_SUBDIRECTORY(doc)


# ============================================================================
# Tell cmake to copy the kissplice main (python) file to bin dir
# ============================================================================
add_custom_target(kissplice ALL
COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/kissplice.py ${MAIN_BIN_DIR}/kissplice)


# ============================================================================
# zlib required for kissreads
# ============================================================================
FIND_PACKAGE(ZLIB REQUIRED)


# ============================================================================
# Add testing capabilities 
# ============================================================================

ENABLE_TESTING()
ADD_SUBDIRECTORY(tests)

# ============================================================================
# Adds the 'dist' target (that will use cpack)
# ============================================================================
add_custom_target(dist COMMAND ${CMAKE_BUILD_TOOL} package_source)


# ============================================================================
# Specify rules to run at install time
# ============================================================================
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/bin/kissplice DESTINATION bin PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)


# ============================================================================
# Add custom uninstall target
# ============================================================================
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/utils/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)




# ============================================================================
# Configure cpack
# ============================================================================
SET(CPACK_PACKAGE_NAME "kissplice")
SET(CPACK_PACKAGE_VENDOR "Kissplice Development Team")
SET(CPACK_PACKAGE_VERSION_MAJOR "2")
SET(CPACK_PACKAGE_VERSION_MINOR "1")
SET(CPACK_PACKAGE_VERSION_PATCH "0")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Splicing events caller")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS")
SET(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL")
SET(CPACK_SOURCE_GENERATOR "TGZ")
SET(CPACK_SOURCE_IGNORE_FILES
 "README.CMake"
 "README.Licence"
 "README.Release"
 "README.NamingConventions"
 "README.Kissreads"
 "CMakeFiles"
 "Makefile"
 "_CPack_Packages"
 "CMakeCache.txt"
 ".*\\\\.svn"
 ".*\\\\.gz"
 ".*\\\\~"
 ".*\\\\.o"
 "bcc/"
 "debruijn/"
 "debruijn-v2"
 "datasets"
 "ismb"
 "Recomb"
 "RR"
 "script_tarjan_aphid.sh"
 "splice_sites_results"
 "splicing_events"
 "TODO.*"
 "Validation"
 "validation_script.sh"
 ".*project"
 "/\\\\.git*"
 "results"
 "build"
 "incremental-bicon.ps"
 "scripts"
 "skeletons"
 "doc/dev"
 "resType0.png"
 "resType1.png"
 "quantifModel.png"
 "ucsc.png"
 "user_guide.aux"  
 "user_guide.bib"  
 "user_guide.log"
 "user_guide.toc"
 "user_guide.tex"
 "integration_tests"
 "functional_tests"
 "jobim13"
 ${CPACK_SOURCE_IGNORE_FILES}
)
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
include(CPack)

=== debruijn-v4/CMakeLists.txt ===
# Manage the KMERS_OVER_32 option for graph construction
if (KMERS_OVER_32)
    add_definitions(-Dkmer_type=__uint128_t)
endif (KMERS_OVER_32)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} )

ADD_EXECUTABLE(ks_debruijn4 main.cpp minia/Pool.cpp minia/Bank.cpp minia/Bloom.cpp minia/Hash16.cpp minia/Kmer.cpp minia/Set.cpp minia/Utils.cpp minia/SortingCount.cpp minia/LinearCounter.cpp minia/Debloom.cpp minia/Traversal.cpp minia/Terminator.cpp minia/OAHash.cpp minia/GraphOutput.cpp minia/Bank.h minia/Debloom.h minia/Hash16.h minia/LinearCounter.h minia/Pool.h minia/SortingCount.h minia/Traversal.h minia/lut.h minia/Bloom.h minia/GraphOutput.h minia/Kmer.h minia/OAHash.h minia/Set.h minia/Terminator.h minia/Utils.h)
TARGET_LINK_LIBRARIES(ks_debruijn4 z)
install(TARGETS ks_debruijn4 DESTINATION lib/kissplice)

=== modules/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} )

ADD_EXECUTABLE(ks_clean_duplicates CleanDuplicates.cpp CycleCompression.cpp NGraph.cpp CGraph.cpp CEdge.cpp LabelledCEdge.cpp NNode.cpp NEdge.cpp Utils.cpp)
install(TARGETS ks_clean_duplicates DESTINATION lib/kissplice)

ADD_EXECUTABLE(ks_bubble_enumeration  BubbleEnumeration.cpp CycleCompression.cpp NGraph.cpp CGraph.cpp CEdge.cpp LabelledCEdge.cpp NNode.cpp NEdge.cpp Utils.cpp)
install(TARGETS ks_bubble_enumeration DESTINATION lib/kissplice)

ADD_EXECUTABLE(ks_run_modules run.cpp CycleCompression.cpp NGraph.cpp CGraph.cpp CEdge.cpp LabelledCEdge.cpp NNode.cpp NEdge.cpp SplitBcc.cpp Utils.cpp)
install(TARGETS ks_run_modules DESTINATION lib/kissplice)

ADD_EXECUTABLE(ks_error_removal ErrorRemoval.cpp CEdge.cpp LabelledCEdge.cpp Utils.cpp)
install(TARGETS ks_error_removal DESTINATION lib/kissplice)

ADD_EXECUTABLE(ks_print_bcc PrintBcc.cpp Utils.cpp)
install(TARGETS ks_print_bcc DESTINATION lib/kissplice)

=== tests/CMakeLists.txt ===
if (INTEGRATION_TESTS)
  ADD_SUBDIRECTORY(integration_tests)
endif (INTEGRATION_TESTS)

if (FUNCTIONAL_TESTS)
  ADD_SUBDIRECTORY(functional_tests)
endif (FUNCTIONAL_TESTS)

=== thirdparty/CMakeLists.txt ===
ADD_SUBDIRECTORY(kissreads)
# Script install
#install(PROGRAMS timeout.sh DESTINATION bin)
# Script in build directory 
#add_custom_target(timeout.sh ALL
#  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/timeout.sh ${CMAKE_BINARY_DIR}/bin/timeout.sh)

=== thirdparty/kissreads/src/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/thirdparty/kissreads/include)

ADD_EXECUTABLE(ks_kissreadsSNPS commons.c extension_algorithm.c interface_libchash.c libchash.c outputs.c coherent_algorithm.c couple.c fragment_index.c kissReads.c list.c tree.c)
set_target_properties(ks_kissreadsSNPS PROPERTIES COMPILE_FLAGS "-DCLASSICAL_SPANNING")


ADD_EXECUTABLE(ks_kissreadsSplice commons.c extension_algorithm.c interface_libchash.c libchash.c outputs.c coherent_algorithm.c couple.c fragment_index.c kissReads.c list.c tree.c)
set_target_properties(ks_kissreadsSplice PROPERTIES COMPILE_FLAGS "-DCLASSICAL_SPANNING -DINPUT_FROM_KISSPLICE")
IF(UNIX)
  TARGET_LINK_LIBRARIES(ks_kissreadsSNPS m)
  TARGET_LINK_LIBRARIES(ks_kissreadsSplice m)
ENDIF(UNIX)
TARGET_LINK_LIBRARIES(ks_kissreadsSNPS z)
TARGET_LINK_LIBRARIES(ks_kissreadsSplice z)

install(TARGETS ks_kissreadsSNPS DESTINATION lib/kissplice)
install(TARGETS ks_kissreadsSplice DESTINATION lib/kissplice)

=== debian/changelog ===
kissplice (2.1.0-1) unstable; urgency=medium

  * New upstream version
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Fri, 31 Jan 2014 18:13:40 +0100

kissplice (1.8.3-1) unstable; urgency=low

  * Initial debian release (Closes: #711946)
  
 -- David Parsons <david.parsons@inria.fr>  Wed, 05 Jun 2013 12:00:35 +0200

=== debian/control ===
Source: kissplice
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: David Parsons <david.parsons@inria.fr>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9.0),
               cmake,
               python,
               python3,
               zlib1g-dev
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/kissplice/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/kissplice/trunk/
Homepage: http://kissplice.prabi.fr/

Package: kissplice
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python:Depends}
Description: Detection of various kinds of polymorphisms in RNA-seq data
 KisSplice is a piece of software that enables the analysis of RNA-seq data
 with or without a reference genome. It is an exact local transcriptome
 assembler that allows one to identify SNPs, indels and alternative splicing
 events. It can deal with an arbitrary number of biological conditions, and
 will quantify each variant in each condition.
 It has been tested on Illumina datasets of up to 1G reads.
 Its memory consumption is around 5Gb for 100M reads.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with python3 --with python2

override_dh_compress:
	dh_compress --exclude=.pdf

=== debian/watch ===
version=3
http://kissplice.prabi.fr/download/index.php https://gforge.inria.fr/frs/download.php/.*/kissplice-(.*)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip)

## kissplice 2.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -47,22 +47,13 @@
   set(KMERS_OVER_32 ON CACHE BOOL KMERS_OVER_32_HELP_STRING)
 ENDIF ()
 
+
 # ============================================================================
 # Tell cmake which directory to put executables files in
 # ============================================================================
 SET(MAIN_BIN_DIR ${PROJECT_BINARY_DIR}/bin)           # Main program
 SET(SEC_BIN_DIR ${PROJECT_BINARY_DIR}/lib/kissplice)  # Other executables
 SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SEC_BIN_DIR})
-
-
-# ============================================================================
-# Tell cmake about subdirectories to look into
-# ============================================================================
-ADD_SUBDIRECTORY(debruijn-v4)
-ADD_SUBDIRECTORY(thirdparty)
-ADD_SUBDIRECTORY(modules)
-ADD_SUBDIRECTORY(man)
-ADD_SUBDIRECTORY(doc)
 
 
 # ============================================================================
@@ -79,11 +70,21 @@
 
 
 # ============================================================================
+# Tell cmake about subdirectories to look into
+# ============================================================================
+ADD_SUBDIRECTORY(debruijn-v4)
+ADD_SUBDIRECTORY(thirdparty)
+ADD_SUBDIRECTORY(modules)
+ADD_SUBDIRECTORY(man)
+ADD_SUBDIRECTORY(doc)
+
+
+# ============================================================================
 # Add testing capabilities 
 # ============================================================================
-
 ENABLE_TESTING()
 ADD_SUBDIRECTORY(tests)
+
 
 # ============================================================================
 # Adds the 'dist' target (that will use cpack)
@@ -117,8 +118,8 @@
 SET(CPACK_PACKAGE_NAME "kissplice")
 SET(CPACK_PACKAGE_VENDOR "Kissplice Development Team")
 SET(CPACK_PACKAGE_VERSION_MAJOR "2")
-SET(CPACK_PACKAGE_VERSION_MINOR "1")
-SET(CPACK_PACKAGE_VERSION_PATCH "0")
+SET(CPACK_PACKAGE_VERSION_MINOR "2")
+SET(CPACK_PACKAGE_VERSION_PATCH "1")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Splicing events caller")
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
 SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS")
@@ -159,6 +160,8 @@
  "scripts"
  "skeletons"
  "doc/dev"
+ "alt_splicing_sample_ex.png"
+ "quantifModel-big.png"
  "resType0.png"
  "resType1.png"
  "quantifModel.png"
@@ -168,8 +171,6 @@
  "user_guide.log"
  "user_guide.toc"
  "user_guide.tex"
- "integration_tests"
- "functional_tests"
  "jobim13"
  ${CPACK_SOURCE_IGNORE_FILES}
 )

=== debruijn-v4/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,9 @@
 endif (KMERS_OVER_32)
 INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} )
 
+include_directories(${ZLIB_INCLUDE_DIRS})
+
 ADD_EXECUTABLE(ks_debruijn4 main.cpp minia/Pool.cpp minia/Bank.cpp minia/Bloom.cpp minia/Hash16.cpp minia/Kmer.cpp minia/Set.cpp minia/Utils.cpp minia/SortingCount.cpp minia/LinearCounter.cpp minia/Debloom.cpp minia/Traversal.cpp minia/Terminator.cpp minia/OAHash.cpp minia/GraphOutput.cpp minia/Bank.h minia/Debloom.h minia/Hash16.h minia/LinearCounter.h minia/Pool.h minia/SortingCount.h minia/Traversal.h minia/lut.h minia/Bloom.h minia/GraphOutput.h minia/Kmer.h minia/OAHash.h minia/Set.h minia/Terminator.h minia/Utils.h)
-TARGET_LINK_LIBRARIES(ks_debruijn4 z)
+INCLUDE_DIRECTORIES( ${ZLIB_INCLUDE_DIR} )
+TARGET_LINK_LIBRARIES(ks_debruijn4 ${ZLIB_LIBRARY})
 install(TARGETS ks_debruijn4 DESTINATION lib/kissplice)

=== thirdparty/kissreads/src/CMakeLists.txt ===
--- 
+++ 
@@ -10,8 +10,9 @@
   TARGET_LINK_LIBRARIES(ks_kissreadsSNPS m)
   TARGET_LINK_LIBRARIES(ks_kissreadsSplice m)
 ENDIF(UNIX)
-TARGET_LINK_LIBRARIES(ks_kissreadsSNPS z)
-TARGET_LINK_LIBRARIES(ks_kissreadsSplice z)
+INCLUDE_DIRECTORIES( ${ZLIB_INCLUDE_DIR} )
+TARGET_LINK_LIBRARIES(ks_kissreadsSNPS  ${ZLIB_LIBRARY})
+TARGET_LINK_LIBRARIES(ks_kissreadsSplice  ${ZLIB_LIBRARY})
 
 install(TARGETS ks_kissreadsSNPS DESTINATION lib/kissplice)
 install(TARGETS ks_kissreadsSplice DESTINATION lib/kissplice)

=== debian/changelog ===
kissplice (2.2.1-3) unstable; urgency=medium

  * Architecture attribute in a single line
    Closes: #780473

 -- Andreas Tille <tille@debian.org>  Sat, 14 Mar 2015 22:37:41 +0100

kissplice (2.2.1-2) unstable; urgency=medium

  [ David Parsons ]
  * Restrict architectures to 64Bit only

  [ Andreas Tille ]
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Fri, 10 Oct 2014 11:03:43 +0200

kissplice (2.2.1-1) unstable; urgency=medium

  * New upstream version
  * Fix watch

 -- David Parsons <david.parsons@inria.fr>  Tue, 26 Aug 2014 14:53:50 +0200

=== debian/control ===
--- 
+++ 
@@ -9,13 +9,13 @@
                python,
                python3,
                zlib1g-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/kissplice/trunk/
 Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/kissplice/trunk/
 Homepage: http://kissplice.prabi.fr/
 
 Package: kissplice
-Architecture: any
+Architecture: any-amd64 any-arm64 any-mips64 any-mips64el any-ia64 any-ppc64 any-ppc64el any-sparc64
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          ${python:Depends}

## kissplice 2.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,12 @@
 # Set project name and languages
 # ============================================================================
 PROJECT(kissplice CXX C)
+
+
+# ============================================================================
+# Get GNU standard installation directories (GNUInstallDirs module)
+# ============================================================================
+INCLUDE(GNUInstallDirs)
 
 
 # ============================================================================
@@ -16,14 +22,17 @@
 IF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
     SET(CMAKE_BUILD_TYPE Distribution)
 ENDIF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
-SET(CMAKE_CXX_FLAGS_DEBUG "-g -Wall")
+
+
+SET(CMAKE_CXX_FLAGS_DEBUG "-g -Wall")	      
 SET(CMAKE_C_FLAGS_DEBUG "-g -Wall")
 SET(CMAKE_CXX_FLAGS_RELEASE "-O3 -Wall")
 SET(CMAKE_C_FLAGS_RELEASE "-O3 -Wall")
 SET(CMAKE_CXX_FLAGS_DISTRIBUTION "-O3 -w")
 SET(CMAKE_C_FLAGS_DISTRIBUTION "-O3 -w")
-SET(CMAKE_CXX_FLAGS_PROFILING "-g -pg")
+SET(CMAKE_CXX_FLAGS_PROFILING "-g -pg") 
 SET(CMAKE_C_FLAGS_PROFILING "-g -pg")
+
 
 
 # ============================================================================
@@ -49,18 +58,39 @@
 
 
 # ============================================================================
-# Tell cmake which directory to put executables files in
-# ============================================================================
-SET(MAIN_BIN_DIR ${PROJECT_BINARY_DIR}/bin)           # Main program
-SET(SEC_BIN_DIR ${PROJECT_BINARY_DIR}/lib/kissplice)  # Other executables
+# Tell cmake where to put binary files.
+# By GNU standards "executable programs that users can run" should go in
+# bindir a.k.a ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}
+# and "executable programs to be run by other programs rather than by users"
+# in libexecdir a.k.a ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}
+#
+# The main script of kissplice (kissplice.py) must be configured to find the
+# secondary binaries. These can be found either in libexecdir (after install)
+# or in the build-tree, we hence need 2 versions of kissplice: one that uses
+# those secondary binaries in the build-tree and one that is installable.
+# The latter will be placed in an ad-hoc directory called "install" in the
+# build-tree
+#
+# Since all the files to be *compiled* belong to libexecdir, we can set
+# ${CMAKE_RUNTIME_OUTPUT_DIRECTORY} once and for all her
+# ============================================================================
+# Set main binary dir
+SET(MAIN_BIN_DIR ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
+# Set the location of other executables
+SET(SEC_BIN_DIR ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBEXECDIR}/kissplice)
+
+# Tell cmake where to put compiled files
 SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SEC_BIN_DIR})
 
-
-# ============================================================================
-# Tell cmake to copy the kissplice main (python) file to bin dir
-# ============================================================================
-add_custom_target(kissplice ALL
-COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/kissplice.py ${MAIN_BIN_DIR}/kissplice)
+# Make a configured copy of kissplice main (python) file
+# KS_SEC_EXEC_PATH must be a relative path to support local installations using
+# make install DESTDIR=/some/path
+set(KS_SEC_EXEC_PATH ${CMAKE_INSTALL_LIBEXECDIR}/kissplice)
+configure_file(${PROJECT_SOURCE_DIR}/kissplice.py ${MAIN_BIN_DIR}/kissplice @ONLY)
+
+# Tell cmake where to install the main script (kissplice)
+install(PROGRAMS ${MAIN_BIN_DIR}/kissplice
+        DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})
 
 
 # ============================================================================
@@ -80,7 +110,7 @@
 
 
 # ============================================================================
-# Add testing capabilities 
+# Add testing capabilities
 # ============================================================================
 ENABLE_TESTING()
 ADD_SUBDIRECTORY(tests)
@@ -90,12 +120,6 @@
 # Adds the 'dist' target (that will use cpack)
 # ============================================================================
 add_custom_target(dist COMMAND ${CMAKE_BUILD_TOOL} package_source)
-
-
-# ============================================================================
-# Specify rules to run at install time
-# ============================================================================
-install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/bin/kissplice DESTINATION bin PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
 
 
 # ============================================================================
@@ -118,7 +142,7 @@
 SET(CPACK_PACKAGE_NAME "kissplice")
 SET(CPACK_PACKAGE_VENDOR "Kissplice Development Team")
 SET(CPACK_PACKAGE_VERSION_MAJOR "2")
-SET(CPACK_PACKAGE_VERSION_MINOR "2")
+SET(CPACK_PACKAGE_VERSION_MINOR "3")
 SET(CPACK_PACKAGE_VERSION_PATCH "1")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Splicing events caller")
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
@@ -166,8 +190,8 @@
  "resType1.png"
  "quantifModel.png"
  "ucsc.png"
- "user_guide.aux"  
- "user_guide.bib"  
+ "user_guide.aux"
+ "user_guide.bib"
  "user_guide.log"
  "user_guide.toc"
  "user_guide.tex"

=== debruijn-v4/CMakeLists.txt ===
# Manage the KMERS_OVER_32 option for graph construction
if (KMERS_OVER_32)
    add_definitions(-Dkmer_type=__uint128_t)
endif (KMERS_OVER_32)
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

include_directories(${ZLIB_INCLUDE_DIRS})

add_executable(ks_debruijn4 main.cpp minia/Pool.cpp minia/Bank.cpp minia/Bloom.cpp minia/Hash16.cpp minia/Kmer.cpp minia/Set.cpp minia/Utils.cpp minia/SortingCount.cpp minia/LinearCounter.cpp minia/Debloom.cpp minia/Traversal.cpp minia/Terminator.cpp minia/OAHash.cpp minia/GraphOutput.cpp minia/Bank.h minia/Debloom.h minia/Hash16.h minia/LinearCounter.h minia/Pool.h minia/SortingCount.h minia/Traversal.h minia/lut.h minia/Bloom.h minia/GraphOutput.h minia/Kmer.h minia/OAHash.h minia/Set.h minia/Terminator.h minia/Utils.h)

# Declare use of c++11 features
# TODO: This conditional should be removed as soon as cmake 2.8.12 or greater
# becomes acceptable as a requirement since the solution using target_compile_options
# (introduced in 2.8.12) is a lot cleaner.
IF ((${CMAKE_VERSION} VERSION_LESS 2.8.12) )
  SET(CMAKE_C_FLAGS_DEBUG   "${CMAKE_C_FLAGS_DEBUG} -std=c++11")
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -std=c++11")
  SET(CMAKE_C_FLAGS_RELEASE   "${CMAKE_C_FLAGS_RELEASE} -std=c++11")
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -std=c++11")
  SET(CMAKE_C_FLAGS_DISTRIBUTION    "${CMAKE_C_FLAGS_DISTRIBUTION} -std=c++11")
  SET(CMAKE_CXX_FLAGS_DISTRIBUTION  "${CMAKE_CXX_FLAGS_DISTRIBUTION} -std=c++11")
  SET(CMAKE_C_FLAGS_PROFILING   "${CMAKE_C_FLAGS_PROFILING} -std=c++11")
  SET(CMAKE_CXX_FLAGS_PROFILING "${CMAKE_CXX_FLAGS_PROFILING} -std=c++11")
ELSE ()
  target_compile_options(ks_debruijn4 PRIVATE "-std=c++11")
ENDIF ()


include_directories( ${ZLIB_INCLUDE_DIR} )
target_link_libraries(ks_debruijn4 ${ZLIB_LIBRARY})

install(TARGETS ks_debruijn4 DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/kissplice)

=== modules/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} )

ADD_EXECUTABLE(ks_clean_duplicates CleanDuplicates.cpp CycleCompression.cpp NGraph.cpp CGraph.cpp CEdge.cpp LabelledCEdge.cpp NNode.cpp NEdge.cpp Utils.cpp)
install(TARGETS ks_clean_duplicates DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/kissplice)

ADD_EXECUTABLE(ks_bubble_enumeration  BubbleEnumeration.cpp CycleCompression.cpp NGraph.cpp CGraph.cpp CEdge.cpp LabelledCEdge.cpp NNode.cpp NEdge.cpp Utils.cpp)
install(TARGETS ks_bubble_enumeration DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/kissplice)

ADD_EXECUTABLE(ks_run_modules run.cpp CycleCompression.cpp NGraph.cpp CGraph.cpp CEdge.cpp LabelledCEdge.cpp NNode.cpp NEdge.cpp SplitBcc.cpp Utils.cpp)
install(TARGETS ks_run_modules DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/kissplice)

ADD_EXECUTABLE(ks_error_removal ErrorRemoval.cpp CEdge.cpp LabelledCEdge.cpp Utils.cpp)
install(TARGETS ks_error_removal DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/kissplice)

ADD_EXECUTABLE(ks_print_bcc PrintBcc.cpp Utils.cpp)
install(TARGETS ks_print_bcc DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/kissplice)

=== tests/functional_tests/CMakeLists.txt ===
# ============================================================================
# Tests on: /data/HBM75brain_1000000.fasta 
#      +   /data/HBM75liver_1000000.fasta
# ============================================================================
add_test(ksBubbleEnumerationTest ${CMAKE_CURRENT_SOURCE_DIR}/ksBubbleEnumerationTest.py ${SEC_BIN_DIR})
set_tests_properties(ksBubbleEnumerationTest PROPERTIES PASS_REGULAR_EXPRESSION "test SUCCESSFUL")

# ============================================================================
# Tests on: /data/HBM75brain_1000000.fasta 
#      +   /data/HBM75liver_1000000.fasta
# ============================================================================
add_test(ksRunModulesTest ${CMAKE_CURRENT_SOURCE_DIR}/ksRunModulesTest.py ${SEC_BIN_DIR})
set_tests_properties(ksRunModulesTest PROPERTIES PASS_REGULAR_EXPRESSION "test SUCCESSFUL")

# ============================================================================
# Tests on: /data/HBM75brain_1000000.fasta 
#      +   /data/HBM75liver_1000000.fasta
# ============================================================================
add_test(ksErrorRemovalTest ${CMAKE_CURRENT_SOURCE_DIR}/ksErrorRemovalTest.py ${SEC_BIN_DIR})
set_tests_properties(ksErrorRemovalTest PROPERTIES PASS_REGULAR_EXPRESSION "test SUCCESSFUL")

=== debian/changelog ===
kissplice (2.3.1-1build1) wily; urgency=medium

  * No-change rebuild for python3.5 transition

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 22 Jul 2015 17:17:31 +0000

kissplice (2.3.1-1) unstable; urgency=medium

  * New upstream version
  * Force installation of secondary binaries in lib rather than libexec

 -- David Parsons <david.parsons@inria.fr>  Wed, 22 Apr 2015 16:26:53 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: kissplice
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: David Parsons <david.parsons@inria.fr>,
            Andreas Tille <tille@debian.org>
 Section: science

=== debian/rules ===
--- 
+++ 
@@ -7,5 +7,8 @@
 %:
 	dh $@ --with python3 --with python2
 
+override_dh_auto_configure:
+	dh_auto_configure -- -DCMAKE_INSTALL_LIBEXECDIR=lib/
+
 override_dh_compress:
 	dh_compress --exclude=.pdf

=== debian/watch ===
version=3
http://kissplice.prabi.fr/download/index.php ftp://pbil.univ-lyon1.fr/pub/logiciel/kissplice/download/kissplice-(.*)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip)

## kissplice 2.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # ============================================================================
 # Require minimal version of cmake
 # ============================================================================
-CMAKE_MINIMUM_REQUIRED(VERSION 2.6.4)
+CMAKE_MINIMUM_REQUIRED(VERSION 2.8.5)
 
 
 # ============================================================================
@@ -142,8 +142,8 @@
 SET(CPACK_PACKAGE_NAME "kissplice")
 SET(CPACK_PACKAGE_VENDOR "Kissplice Development Team")
 SET(CPACK_PACKAGE_VERSION_MAJOR "2")
-SET(CPACK_PACKAGE_VERSION_MINOR "3")
-SET(CPACK_PACKAGE_VERSION_PATCH "1")
+SET(CPACK_PACKAGE_VERSION_MINOR "4")
+SET(CPACK_PACKAGE_VERSION_PATCH "0-p1")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Splicing events caller")
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
 SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS")
@@ -160,6 +160,8 @@
  "_CPack_Packages"
  "CMakeCache.txt"
  ".*\\\\.svn"
+ ".*\\\\.idea"
+ ".*\\\\.DS_Store"
  ".*\\\\.gz"
  ".*\\\\~"
  ".*\\\\.o"

## kissplice 2.4.0-p1

=== debian/changelog ===
kissplice (2.4.0-p1-5ubuntu1) focal; urgency=medium

  * Build-depend on python-all-dev.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 18 Mar 2020 15:03:42 +0100

kissplice (2.4.0-p1-5build1) focal; urgency=medium

  * No-change rebuild to generate dependencies on python2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Dec 2019 12:34:53 +0000

kissplice (2.4.0-p1-5) unstable; urgency=medium

  * Team upload.

  [ Saira Hussain ]
  * Add autopkgtest

  [ Andreas Tille ]
  * debhelper-compat 12
  * Standards-Version: 4.4.0

 -- Saira Hussain <saira.h0213@zoho.com>  Mon, 12 Aug 2019 12:07:18 +0100

kissplice (2.4.0-p1-4) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Use secure copyright file specification URI.

  [ Andreas Tille ]
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.3.0

 -- Andreas Tille <tille@debian.org>  Tue, 08 Jan 2019 12:48:29 +0100

kissplice (2.4.0-p1-3) unstable; urgency=medium

  * Add dh-python to Build-Depends since this will be dropped from
    python-dev's Depends soon
  * Standards-Version: 4.1.3
  * debhelper 11
  * do not parse d/changelog
  * d/watch: Checked that https does not work

 -- Andreas Tille <tille@debian.org>  Mon, 26 Mar 2018 17:15:22 +0200

kissplice (2.4.0-p1-2) unstable; urgency=medium

  [ Steffen Moeller ]
  * debian/upstream/metadata:
    - yamllint cleanliness
    - Added references to registries
  * debian/copyright: corrected Upstream-Name spelling

  [ Andreas Tille ]
  * Moved packaging from SVN to Git
  * debhelper 10
  * Standards-Version: 4.1.1

 -- Andreas Tille <tille@debian.org>  Wed, 15 Nov 2017 14:19:37 +0100

kissplice (2.4.0-p1-1) unstable; urgency=medium

  [ David Parsons ]
  * New upstream version

  [ Steffen Moeller ]
  * Introduced EDAM ontology description to debian/upstream/edam.

  [ Andreas Tille ]
  * hardening=+all
  * kissplice is Python but not Python3
  * make proper use of dh_python
  * cme fix dpkg-control

 -- David Parsons <david.parsons@inria.fr>  Thu, 01 Sep 2016 13:30:59 +0200

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: kissplice
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: David Parsons <david.parsons@inria.fr>,
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9.0),
+Build-Depends: debhelper-compat (= 12),
+               dh-python,
                cmake,
-               python,
-               python3,
+               python-all-dev,
                zlib1g-dev
-Standards-Version: 3.9.6
-Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/kissplice/trunk/
-Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/kissplice/trunk/
+Standards-Version: 4.4.0
+Vcs-Browser: https://salsa.debian.org/med-team/kissplice
+Vcs-Git: https://salsa.debian.org/med-team/kissplice.git
 Homepage: http://kissplice.prabi.fr/
 
 Package: kissplice

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

%:
	dh $@ --with python2

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBEXECDIR=lib/

override_dh_compress:
	dh_compress --exclude=.pdf

override_dh_install:
	mkdir -p debian/$(DEB_SOURCE)/usr/share/$(DEB_SOURCE)
	mv debian/$(DEB_SOURCE)/usr/bin/kissplice debian/$(DEB_SOURCE)/usr/share/$(DEB_SOURCE)/kissplice.py

=== debian/watch ===
version=4

http://kissplice.prabi.fr/download/index.php ftp://pbil.univ-lyon1.fr/pub/logiciel/kissplice/download/kissplice-(.*)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip)
